//************************************************************************
// Example11SearchAndSort.java
//
// This example deals with some algorithms for searching and sorting.
//************************************************************************

public class Example11SearchAndSort
{
   public static void main (String[] args)
   {
      IntArray myArray = new IntArray (new int[] {3, 2, 9, 7, -3, 2, 3});
      System.out.println (myArray + "\n" + myArray.linearSearch (3) + " " +
                                           myArray.linearSearch (5));
      myArray.insertionSort();
      System.out.println (myArray);
      myArray = new IntArray (new int[] {3, 2, 9, 7, -3, 2, 3});
      myArray.selectionSort();
      System.out.println (myArray);
      myArray = new IntArray (new int[] {3, 2, 9, 7, -3, 2, 3});
      myArray.mergeSort();
      System.out.println (myArray + "\n" + myArray.binarySearch (3) + " " +
                                           myArray.binarySearch (5));
   }
}


class IntArray
{
   int[] array;

   IntArray (int[] array)
   {this.array = array;}

   int linearSearch (int value)
   {
      //=====================================================================
      // Returns the first occurrence of value in the array (-1 if it does
      // not occur).
      //=====================================================================
      int position = 0;
      while (position <= array.length - 2 & array[position] != value)
         position++;
      if (array[position] == value)
         return position;
      else
         return -1;
   }

   int binarySearch (int value) // much faster, works only for sorted arrays
   {return binarySearch (value, 0, array.length-1);}

   private int binarySearch (int value, int from, int to)
   {
      if (from == to)
      {
         if (array[from] == value) 
            return from;
         else return -1;
      }
      else
      {
         int middle = (from + to) / 2;
         if (array[middle] < value)
            return binarySearch (value, middle + 1, to);
         else
            return binarySearch (value, from, middle);
      }
   }// method binarySearch

   void insertionSort()
   {
      for (int i = 0; i < array.length; i++)
      {
         //shifting larger values
         int valueToInsert = array[i], position = i;
         while (position > 0 && array[position - 1] > valueToInsert)
         {
            array[position] = array[position - 1];
            position--;
         }
         array[position] = valueToInsert;
      }
   }// method insertionSort
 
   void selectionSort()
   {
      for (int i = 0; i < array.length - 1; i++)
         for (int j = i + 1; j < array.length; j++)
            if (array[i] > array[j])
               swap(i,j);
   }// method selectionSort

   void swap (int i, int j)
   {
      int temp = array[i];
      array[i] = array[j];
      array[j] = temp;
   }// method swap
   
   void mergeSort()
   {mergeSort (0, array.length - 1);}

   void mergeSort (int from, int to)
   {
      if (from == to)
         return;
      else
      {
         int middle = (from + to) / 2;
         mergeSort (from, middle);
         mergeSort (middle + 1, to);
         merge (from, middle, to);
      }
}// method mergeSort

   private void merge (int from, int middle, int to)
   {
      int[] temp = new int [to + 1 - from];
      int i = from;
      int j = middle + 1;
      for (int k=0; k < temp.length; k++)
      {
         int val;
         if (i <= middle & (j > to || array[i] < array[j]))
            {
               temp[k] = array[i];
               i++;
            }
            else
            {
               temp[k] = array[j];
               j++;
            }
      }
      for (int k = from; k < to + 1; k++)
         array[k] = temp[k-from];
   }// merge

   public String toString()
   {
      String result = "";
      for (int i = 0; i < array.length; i++)
         result += array[i] + " ";
      return result;
   }// method toString
}// class IntArray
